module Main where

import Text.Read (readMaybe)

data Token = X | O | E deriving (Show, Eq)

type Board = [[Token]]

emptyBoard :: Int -> Board
emptyBoard = undefined

isFull :: Board -> Bool
isFull = undefined

showBoard :: Board -> String
showBoard = undefined

updateListM :: Int -> (a -> Maybe a) -> [a] -> Maybe [a]
updateListM = undefined

setToken :: (Int, Int) -> Token -> Board -> Maybe Board
setToken = undefined

winner :: Board -> Token
winner = undefined
    
main :: IO ()
main = run (emptyBoard 3) X where

  run :: Board -> Token -> IO ()
  run b t = do
    putStrLn $ showBoard b ++ "\n"
    putStr $ "Where to place " ++ show t ++ "? "
    line <- getLine
    case readMaybe line of
      Nothing -> do
        putStrLn "Invalid input... Try again!"
        run b t
      Just pos -> do
        putStrLn ""
        case setToken pos t b of
          Nothing -> do
            putStrLn "Invalid position... Try again!"
            run b t
          Just b' -> do
            case winner b' of
              E | isFull b' -> do
                putStrLn $ showBoard b' ++ "\n"
                putStrLn "Game over. Everyone looses."
              E -> do
                run b' (flipTok t)
              t' -> do
                putStrLn $ showBoard b' ++ "\n"
                putStrLn $ show t' ++ " is the winner!"

  flipTok :: Token -> Token
  flipTok X = O
  flipTok O = X
  flipTok E = E
